diff --git a/src/backend/optimizer/util/clauses.c b/src/backend/optimizer/util/clauses.c
index 13e89ec..b39ebb6 100644
--- a/src/backend/optimizer/util/clauses.c
+++ b/src/backend/optimizer/util/clauses.c
@@ -4300,12 +4300,13 @@ inline_set_returning_function(PlannerInfo *root, RangeTblEntry *rte)
 												 fexpr->args);
 
 	/*
-	 * Copy the modified query out of the temporary memory context, and clean
-	 * up.
+	 * Copy the modified query, and the possibly-altered global invalidation
+	 * list, out of the temporary memory context, and clean up.
 	 */
 	MemoryContextSwitchTo(oldcxt);
 
 	querytree = copyObject(querytree);
+	root->glob->invalItems = copyObject(root->glob->invalItems);
 
 	MemoryContextDelete(mycxt);
 	error_context_stack = sqlerrcontext.previous;
